Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 2178190 - Review Request: mmlib - OS abstraction layer and helpers
Summary: Review Request: mmlib - OS abstraction layer and helpers
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Sandro
QA Contact: Fedora Extras Quality Assurance
URL: https://opensource.mindmaze.com/proje...
Whiteboard:
Depends On:
Blocks: fedora-neuro, NeuroFedora
TreeView+ depends on / blocked
 
Reported: 2023-03-14 13:59 UTC by Ben Beasley
Modified: 2023-04-15 02:03 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2023-03-29 17:28:16 UTC
Type: ---
Embargoed:
gui1ty: fedora-review+


Attachments (Terms of Use)
The .spec file difference from Copr build 5640709 to 5726681 (deleted)
2023-03-29 13:22 UTC, Jakub Kadlčík
no flags Details | Diff

Description Ben Beasley 2023-03-14 13:59:15 UTC
Spec URL: https://music.fedorapeople.org/mmlib.spec
SRPM URL: https://music.fedorapeople.org/mmlib-1.4.2-1.fc37.src.rpm

Description:

mmlib is an Operating System abstraction layer.

It provides an API for application developer, so that they can write portable
code using relatively advanced OS features without having to care about system
specifics.

The reference design in mind in its conception is POSIX, meaning that if some
posix functionality is not available for given platform, mmlib will implement
that same functionality itself.

Fedora Account System Username: music

Koji scratch builds:

F39: https://koji.fedoraproject.org/koji/taskinfo?taskID=98686252
F38: https://koji.fedoraproject.org/koji/taskinfo?taskID=98686254
F37: https://koji.fedoraproject.org/koji/taskinfo?taskID=98686255
F36: https://koji.fedoraproject.org/koji/taskinfo?taskID=98686256

This library is required for updating eegview[1] to version 1.0[2].

[1] https://src.fedoraproject.org/rpms/eegview/
[2] https://github.com/mmlabs-mindmaze/eegview/releases/tag/1.0

Comment 1 Jakub Kadlčík 2023-03-14 14:07:13 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/5640709
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2178190-mmlib/fedora-rawhide-x86_64/05640709-mmlib/fedora-review/review.txt

Please take a look if any issues were found.

---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 2 Sandro 2023-03-29 12:41:13 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

===== Issues =====

[!]: License field in the package spec file matches the actual license.
=> License string appears to be incomplete. See: https://download.copr.fedorainfracloud.org/results/%40fedora-review/fedora-review-2178190-mmlib/fedora-rawhide-x86_64/05640709-mmlib/fedora-review/licensecheck.txt

[!]: Large documentation must go in a -doc subpackage.
=> The main package does not contain any doc files. I would suggest to make README.md and TODO.md part of the main package. Maybe the example/ dir as well.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* Apache License 2.0",
     "Apache License 2.0", "FSF All Permissive License", "*No copyright*
     NTP License". 183 files have unknown license. Detailed output of
     licensecheck in /home/sandro/devel/fedora/fedora-
     review/2178190-mmlib/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[!]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 8 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.

Comment 3 Ben Beasley 2023-03-29 13:09:03 UTC
Thank you for the review!

(In reply to Sandro from comment #2)
> ===== Issues =====
> 
> [!]: License field in the package spec file matches the actual license.
> => License string appears to be incomplete. See:
> https://download.copr.fedorainfracloud.org/results/%40fedora-review/fedora-
> review-2178190-mmlib/fedora-rawhide-x86_64/05640709-mmlib/fedora-review/
> licensecheck.txt

I think it’s complete. The following are the files for which licensecheck detects something other than Apache-2.0:

*No copyright* NTP License
--------------------------
mmlib-1.4.2/src/mmtime.h

FSF All Permissive License
--------------------------
mmlib-1.4.2/m4/mm_python_module.m4

For src/mmtime.h, if you look at the file itself, there is nothing about licenses at all. Instead, licensecheck is confused because the file happens to mention NTP—the software, not the license—in a comment. We may safely assume that the license for this file matches the rest of the software.

For m4/mm_python_module.m4, this is an m4 script that belongs to the autotools build system. It would be used via autogen.sh to build the configure script from configure.ac. Since the file is not installed directly, and its contents are not compiled into anything that appears in the binary RPMs, its license does not contribute to the licenses of the binary RPMs. (We don’t even use the autotools build system for the RPM, preferring Meson instead, but the preceding applies either way.) See: https://docs.fedoraproject.org/en-US/packaging-guidelines/LicensingGuidelines/#_license_field

> 
> [!]: Large documentation must go in a -doc subpackage.
> => The main package does not contain any doc files. I would suggest to make
> README.md and TODO.md part of the main package. Maybe the example/ dir as
> well.

I don’t feel too strongly about whether README.md and TODO.md should appear in the base/library package or not. I am not convinced they are wrong as they are, but I do not mind moving them from the -devel package to the base package. I am not convinced there is a use case where installing the examples in the base package makes sense; who will want C sources that demonstrate developing programs that use the library, but will not want the headers and unversioned .so link needed to do so themselves? I plan to leave the examples in the -devel package.

Comment 4 Ben Beasley 2023-03-29 13:10:47 UTC
In the following, README.md and TODO.md have been moved from mmlib-devel to mmlib.

New Spec URL: https://music.fedorapeople.org/20230329/mmlib.spec
New SRPM URL: https://music.fedorapeople.org/20230329/mmlib-1.4.2-1.fc37.src.rpm

Comment 5 Jakub Kadlčík 2023-03-29 13:22:01 UTC
Created attachment 1954412 [details]
The .spec file difference from Copr build 5640709 to 5726681

Comment 6 Jakub Kadlčík 2023-03-29 13:22:03 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/5726681
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2178190-mmlib/fedora-rawhide-x86_64/05726681-mmlib/fedora-review/review.txt

Please take a look if any issues were found.

---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 7 Sandro 2023-03-29 13:26:48 UTC
(In reply to Ben Beasley from comment #3)
> Thank you for the review!
> 
> (In reply to Sandro from comment #2)
> > ===== Issues =====
> > 
> > [!]: License field in the package spec file matches the actual license.
> > => License string appears to be incomplete. See:
> > https://download.copr.fedorainfracloud.org/results/%40fedora-review/fedora-
> > review-2178190-mmlib/fedora-rawhide-x86_64/05640709-mmlib/fedora-review/
> > licensecheck.txt
> 
> I think it’s complete. The following are the files for which licensecheck
> detects something other than Apache-2.0:
> 
> *No copyright* NTP License
> --------------------------
> mmlib-1.4.2/src/mmtime.h
> 
> FSF All Permissive License
> --------------------------
> mmlib-1.4.2/m4/mm_python_module.m4

Your explanation makes sense. No action required. I should have looked into the files myself. Thanks for the extended feedback.

(In reply to Ben Beasley from comment #4)
> In the following, README.md and TODO.md have been moved from mmlib-devel to
> mmlib.

I think it makes sense to have these in the main package (and it means one less warning from rpmlint). Keeping examples/ in the devel package is also okay.

All in all ==> APPROVED!

Comment 8 Fedora Admin user for bugzilla script actions 2023-03-29 17:08:30 UTC
The Pagure repository was created at https://src.fedoraproject.org/rpms/mmlib

Comment 9 Ben Beasley 2023-03-29 17:09:10 UTC
Thanks again for the review!

Comment 10 Fedora Update System 2023-03-29 17:23:43 UTC
FEDORA-2023-74c61b728f has been submitted as an update to Fedora 39. https://bodhi.fedoraproject.org/updates/FEDORA-2023-74c61b728f

Comment 11 Fedora Update System 2023-03-29 17:28:16 UTC
FEDORA-2023-74c61b728f has been pushed to the Fedora 39 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 12 Fedora Update System 2023-03-29 20:55:32 UTC
FEDORA-2023-29e6883292 has been submitted as an update to Fedora 38. https://bodhi.fedoraproject.org/updates/FEDORA-2023-29e6883292

Comment 13 Fedora Update System 2023-03-29 21:06:49 UTC
FEDORA-2023-c558888954 has been submitted as an update to Fedora 37. https://bodhi.fedoraproject.org/updates/FEDORA-2023-c558888954

Comment 14 Fedora Update System 2023-03-29 21:35:44 UTC
FEDORA-2023-9f1759144f has been submitted as an update to Fedora 36. https://bodhi.fedoraproject.org/updates/FEDORA-2023-9f1759144f

Comment 15 Fedora Update System 2023-03-30 02:00:54 UTC
FEDORA-2023-9f1759144f has been pushed to the Fedora 36 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --refresh --advisory=FEDORA-2023-9f1759144f \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2023-9f1759144f

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 16 Fedora Update System 2023-03-30 02:20:34 UTC
FEDORA-2023-29e6883292 has been pushed to the Fedora 38 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2023-29e6883292

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 17 Fedora Update System 2023-03-30 02:35:12 UTC
FEDORA-2023-c558888954 has been pushed to the Fedora 37 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --refresh --advisory=FEDORA-2023-c558888954 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2023-c558888954

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 18 Fedora Update System 2023-03-30 11:46:43 UTC
FEDORA-EPEL-2023-92196bc05e has been submitted as an update to Fedora EPEL 9. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2023-92196bc05e

Comment 19 Fedora Update System 2023-03-30 12:40:32 UTC
FEDORA-EPEL-2023-5bd7956df1 has been submitted as an update to Fedora EPEL 8. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2023-5bd7956df1

Comment 20 Fedora Update System 2023-03-31 02:54:08 UTC
FEDORA-EPEL-2023-92196bc05e has been pushed to the Fedora EPEL 9 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2023-92196bc05e

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 21 Fedora Update System 2023-03-31 02:57:16 UTC
FEDORA-EPEL-2023-5bd7956df1 has been pushed to the Fedora EPEL 8 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2023-5bd7956df1

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 22 Fedora Update System 2023-04-07 02:37:23 UTC
FEDORA-2023-9f1759144f has been pushed to the Fedora 36 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 23 Fedora Update System 2023-04-07 03:00:29 UTC
FEDORA-2023-c558888954 has been pushed to the Fedora 37 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 24 Fedora Update System 2023-04-08 02:03:35 UTC
FEDORA-EPEL-2023-92196bc05e has been pushed to the Fedora EPEL 9 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 25 Fedora Update System 2023-04-08 02:42:00 UTC
FEDORA-EPEL-2023-5bd7956df1 has been pushed to the Fedora EPEL 8 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 26 Fedora Update System 2023-04-15 02:03:21 UTC
FEDORA-2023-29e6883292 has been pushed to the Fedora 38 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.